/**
 * @author Tomasz Waleń (walen@mimuw.edu.pl)
 * @brief Rozwiazanie zadania Obrywanie
 *        https://moodle.mimuw.edu.pl/mod/assign/view.php?id=77175
 * @date 2022-01-25
 */
#include <stdio.h>
#include <stdlib.h>

#include "drzewo.h"

Twezel *pom(Twezel *d) {
    if (d==NULL) return NULL;
    else if (d->lsyn==d->psyn) { // "hackerska" wersja: d->lsyn==NULL && d->psyn==NULL
        free(d);
        return NULL;
    } else {
        d->lsyn = pom(d->lsyn);
        d->psyn = pom(d->psyn);
        return d;
    }
}

void oberwij_liscie(Twezel **d) {
    *d = pom(*d);
}

int main(void) {
    Twezel *d = czytaj();

#if defined(DOT)
    prolog_dot();
    pokaz_dot(d, "przed");
#elif defined(JSON)
    prolog_json();
    pokaz_json(d, "przed");
#else
    printf("przed:\n");
    pisz(d);
#endif

    oberwij_liscie(&d);

#if defined(DOT)
    interlog_dot();
    pokaz_dot(d, "po");
    epilog_dot();
#elif defined(JSON)
    interlog_json();
    pokaz_json(d, "po");
    epilog_json();
#else
    printf("\n");
    printf("po: ");
    pisz(d);
#endif

    usun(d);
    return 0;
}
