/**
 * @author Tomasz Waleń (walen@mimuw.edu.pl)
 * @brief Rozwiazanie zadania Spłaszczanie
 *        https://moodle.mimuw.edu.pl/mod/assign/view.php?id=77179
 * @date 2022-01-25
 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "drzewo.h"

/**
 * @brief 
 * 
 * @param d drzewo do spłaszczenia 
 * @param ost ostatni element listy z już spłaszczonymi elementami
 * @return Twezel* ostatni element listy ze wszystkimi starymi elementami + wszystkie element z d
 */
Twezel *pom(Twezel *d, Twezel *ost) {
    assert(ost != NULL && ost->psyn==NULL && ost->lsyn==NULL);
    if (d==NULL)
        return ost;
    else {
        Twezel *tmp = pom(d->lsyn, ost);
        
        /* doklej d na koniec listy */
        Twezel *psyn = d->psyn;
        d->lsyn = NULL;
        d->psyn = NULL;
        tmp->psyn = d;

        Twezel *nowy_ost = pom(psyn, d);
        return nowy_ost;
    }
}

Twezel *splaszcz(Twezel *d) {
    Twezel *straznik = nowy(0, NULL, NULL); // sztuczny element, tak, żeby lista miała 1 element już na początku

    pom(d, straznik);

    // pozbywanie się strażnika
    Twezel *wynik = straznik->psyn;
    free(straznik); // zwolnij pamięć po strażniku

    return wynik;
}

int main(void) {
    Twezel *d = czytaj();

#if defined(DOT)
    prolog_dot();
    pokaz_dot(d, "przed");
#elif defined(JSON)
    prolog_json();
    pokaz_json(d, "przed");
#else
    printf("przed:\n");
    pisz(d);
#endif

    d = splaszcz(d);

#if defined(DOT)
    interlog_dot();
    pokaz_dot(d, "po");
    epilog_dot();
#elif defined(JSON)
    interlog_json();
    pokaz_json(d, "po");
    epilog_json();
#else
    printf("\n");
    printf("po: ");
    pisz(d);
#endif

    usun(d);
    return 0;
}
