/**
 * @author Tomasz Waleń (walen@mimuw.edu.pl)
 * @brief Rozwiazanie zadania Uzupełnianie
 *        https://moodle.mimuw.edu.pl/mod/assign/view.php?id=77181
 * @date 2022-01-25
 */
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "drzewo.h"

int max(int a, int b) {
    return (a>b ? a : b);
}

int wys(Twezel *d) { // wysokość liczoną liczbą krawędzi do najgłębszego liścia
    if (d==NULL) return -1;
    return max(wys(d->lsyn), wys(d->psyn)) + 1;
}

Twezel *pom(Twezel *d, int gl, int wys_drzewa) {
    if (gl <= wys_drzewa) {
        if (d==NULL) d = nowy(0, NULL, NULL); // utwórz jedno elementowe drzewo
        d->lsyn = pom(d->lsyn, gl+1, wys_drzewa);
        d->psyn = pom(d->psyn, gl+1, wys_drzewa);
    } else {
        assert(gl == wys_drzewa+1);
        assert(d == NULL);
    }
    return d;
}

void uzupelnij(Twezel *d) {
    int h = wys(d);
    pom(d, 0, h);
}

int main(void) {
    Twezel *d = czytaj();

#if defined(DOT)
    prolog_dot();
    pokaz_dot(d, "przed");
#elif defined(JSON)
    prolog_json();
    pokaz_json(d, "przed");
#else
    printf("przed:\n");
    pisz(d);
#endif

    uzupelnij(d);

#if defined(DOT)
    interlog_dot();
    pokaz_dot(d, "po");
    epilog_dot();
#elif defined(JSON)
    interlog_json();
    pokaz_json(d, "po");
    epilog_json();
#else
    printf("\n");
    printf("po: ");
    pisz(d);
#endif

    usun(d);
    return 0;
}
